/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
    Pseudo_QC_callref.qpp

    Qore Programming Language

    Copyright (C) 2003 - 2024 Qore Technologies, s.r.o.

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

    Note that the Qore library is released under a choice of three open-source
    licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
    information.
*/

#include <qore/Qore.h>
/* Qore class Qore::<callref> */

qore_classid_t CID_PSEUDOCALLREF;
QoreClass* QC_PSEUDOCALLREF;

// bool PseudoCallref::callp(){}
static QoreValue PseudoCallref_callp(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 93 "Pseudo_QC_Callref.qpp"
    return true;
}

// auto PseudoCallref::exec(...){}
static QoreValue PseudoCallref_exec_VV(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
    const ResolvedCallReferenceNode* c = v.get<ResolvedCallReferenceNode>();
# 79 "Pseudo_QC_Callref.qpp"
    c->execValue(args, xsink);
    return QoreValue();
}

// int PseudoCallref::typeCode(){}
static QoreValue PseudoCallref_typeCode(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 53 "Pseudo_QC_Callref.qpp"
    return NT_FUNCREF;
}

// string PseudoCallref::uniqueHash(){}
static QoreValue PseudoCallref_uniqueHash(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
    const ResolvedCallReferenceNode* c = v.get<ResolvedCallReferenceNode>();
# 105 "Pseudo_QC_Callref.qpp"
    QoreStringNode* rv = new QoreStringNode;
    qore_get_ptr_hash(*rv, c);
    return rv;
}

// bool PseudoCallref::val(){}
static QoreValue PseudoCallref_val(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 70 "Pseudo_QC_Callref.qpp"
    return true;
}

DLLLOCAL void preinitPseudoCallrefClass() {
    QC_PSEUDOCALLREF = new QoreBuiltinClass("<callref>", "::Qore::<callref>", QDOM_DEFAULT);
    CID_PSEUDOCALLREF = QC_PSEUDOCALLREF->getID();
    QC_PSEUDOCALLREF->setSystem();
}

DLLLOCAL QoreClass* initPseudoCallrefClass() {
    if (!QC_PSEUDOCALLREF)
        preinitPseudoCallrefClass();

    // set parent class
    assert(QC_PSEUDOVALUE);
    QC_PSEUDOCALLREF->addBuiltinVirtualBaseClass(QC_PSEUDOVALUE);

    // bool PseudoCallref::callp(){}
    QC_PSEUDOCALLREF->addMethod("callp", (q_method_n_t)PseudoCallref_callp, Public, QCF_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

    // auto PseudoCallref::exec(...){}
    QC_PSEUDOCALLREF->addMethod("exec", (q_method_n_t)PseudoCallref_exec_VV, Public, QCF_USES_EXTRA_ARGS, QDOM_DEFAULT, autoTypeInfo);

    // int PseudoCallref::typeCode(){}
    QC_PSEUDOCALLREF->addMethod("typeCode", (q_method_n_t)PseudoCallref_typeCode, Public, QCF_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

    // string PseudoCallref::uniqueHash(){}
    QC_PSEUDOCALLREF->addMethod("uniqueHash", (q_method_n_t)PseudoCallref_uniqueHash, Public, QCF_CONSTANT, QDOM_DEFAULT, stringTypeInfo);

    // bool PseudoCallref::val(){}
    QC_PSEUDOCALLREF->addMethod("val", (q_method_n_t)PseudoCallref_val, Public, QCF_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

    return QC_PSEUDOCALLREF;
}
