/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  Pseudo_QC_closure.qpp

  Qore Programming Language

  Copyright (C) 2003 - 2023 David Nichols

  Permission is hereby granted, free of charge, to any person obtaining a
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation
  the rights to use, copy, modify, merge, publish, distribute, sublicense,
  and/or sell copies of the Software, and to permit persons to whom the
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
  DEALINGS IN THE SOFTWARE.

  Note that the Qore library is released under a choice of three open-source
  licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
  information.
*/

#include <qore/Qore.h>
/* Qore class Qore::<closure> */

qore_classid_t CID_PSEUDOCLOSURE;
QoreClass* QC_PSEUDOCLOSURE;

// int PseudoClosure::typeCode(){}
static QoreValue PseudoClosure_typeCode(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 53 "Pseudo_QC_Closure.qpp"
    return NT_RUNTIME_CLOSURE;
}

DLLLOCAL void preinitPseudoClosureClass() {
    QC_PSEUDOCLOSURE = new QoreBuiltinClass("<closure>", "::Qore::<closure>", QDOM_DEFAULT);
    CID_PSEUDOCLOSURE = QC_PSEUDOCLOSURE->getID();
    QC_PSEUDOCLOSURE->setSystem();
}

DLLLOCAL QoreClass* initPseudoClosureClass() {
    if (!QC_PSEUDOCLOSURE)
        preinitPseudoClosureClass();

    // set parent class
    assert(QC_PSEUDOCALLREF);
    QC_PSEUDOCLOSURE->addBuiltinVirtualBaseClass(QC_PSEUDOCALLREF);

    // int PseudoClosure::typeCode(){}
    QC_PSEUDOCLOSURE->addMethod("typeCode", (q_method_n_t)PseudoClosure_typeCode, Public, QCF_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

    return QC_PSEUDOCLOSURE;
}
