/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
    Pseudo_QC_Nothing.qpp

    Qore Programming Language

    Copyright (C) 2003 - 2024 Qore Technologies, s.r.o.

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

    Note that the Qore library is released under a choice of three open-source
    licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
    information.
*/

#include <qore/Qore.h>
/* Qore class Qore::<nothing> */

qore_classid_t CID_PSEUDONOTHING;
QoreClass* QC_PSEUDONOTHING;

// SingleValueIterator PseudoNothing::contextIterator(){}
static QoreValue PseudoNothing_contextIterator(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 115 "Pseudo_QC_Nothing.qpp"
    return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(QoreValue()));
}

// nothing PseudoNothing::firstKey(){}
static QoreValue PseudoNothing_firstKey(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 169 "Pseudo_QC_Nothing.qpp"
    
    return QoreValue();
}

// nothing PseudoNothing::firstValue(){}
static QoreValue PseudoNothing_firstValue(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 186 "Pseudo_QC_Nothing.qpp"
    
    return QoreValue();
}

// bool PseudoNothing::hasKey(softstring key){}
static QoreValue PseudoNothing_hasKey_vs(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 239 "Pseudo_QC_Nothing.qpp"
    return false;
}

// bool PseudoNothing::hasKeyValue(softstring key){}
static QoreValue PseudoNothing_hasKeyValue_vs(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 259 "Pseudo_QC_Nothing.qpp"
    return false;
}

// SingleValueIterator PseudoNothing::keyIterator(){}
static QoreValue PseudoNothing_keyIterator(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 99 "Pseudo_QC_Nothing.qpp"
    return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(QoreValue()));
}

// list<string> PseudoNothing::keys(){}
static QoreValue PseudoNothing_keys(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 133 "Pseudo_QC_Nothing.qpp"
    return new QoreListNode(stringTypeInfo);
}

// nothing PseudoNothing::lastKey(){}
static QoreValue PseudoNothing_lastKey(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 203 "Pseudo_QC_Nothing.qpp"
    
    return QoreValue();
}

// nothing PseudoNothing::lastValue(){}
static QoreValue PseudoNothing_lastValue(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 220 "Pseudo_QC_Nothing.qpp"
    
    return QoreValue();
}

// int PseudoNothing::lsize(){}
static QoreValue PseudoNothing_lsize(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 69 "Pseudo_QC_Nothing.qpp"
    return 0;
}

// SingleValueIterator PseudoNothing::pairIterator(){}
static QoreValue PseudoNothing_pairIterator(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 83 "Pseudo_QC_Nothing.qpp"
    return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(QoreValue()));
}

// SingleValueIterator PseudoNothing::rangeIterator(){}
static QoreValue PseudoNothing_rangeIterator(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 275 "Pseudo_QC_Nothing.qpp"
    return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(QoreValue()));
}

// int PseudoNothing::typeCode(){}
static QoreValue PseudoNothing_typeCode(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 53 "Pseudo_QC_Nothing.qpp"
    return NT_NOTHING;
}

// list<auto> PseudoNothing::values(){}
static QoreValue PseudoNothing_values(QoreObject* self, const QoreValue& v, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 151 "Pseudo_QC_Nothing.qpp"
    return new QoreListNode(autoTypeInfo);
}

DLLLOCAL void preinitPseudoNothingClass() {
    QC_PSEUDONOTHING = new QoreBuiltinClass("<nothing>", "::Qore::<nothing>", QDOM_DEFAULT);
    CID_PSEUDONOTHING = QC_PSEUDONOTHING->getID();
    QC_PSEUDONOTHING->setSystem();
}

DLLLOCAL QoreClass* initPseudoNothingClass() {
    if (!QC_PSEUDONOTHING)
        preinitPseudoNothingClass();

    // set parent class
    assert(QC_PSEUDOVALUE);
    QC_PSEUDONOTHING->addBuiltinVirtualBaseClass(QC_PSEUDOVALUE);

    // SingleValueIterator PseudoNothing::contextIterator(){}
    QC_PSEUDONOTHING->addMethod("contextIterator", (q_method_n_t)PseudoNothing_contextIterator, Public, QCF_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

    // nothing PseudoNothing::firstKey(){}
    QC_PSEUDONOTHING->addMethod("firstKey", (q_method_n_t)PseudoNothing_firstKey, Public, QCF_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

    // nothing PseudoNothing::firstValue(){}
    QC_PSEUDONOTHING->addMethod("firstValue", (q_method_n_t)PseudoNothing_firstValue, Public, QCF_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

    // bool PseudoNothing::hasKey(softstring key){}
    QC_PSEUDONOTHING->addMethod("hasKey", (q_method_n_t)PseudoNothing_hasKey_vs, Public, QCF_CONSTANT, QDOM_DEFAULT, boolTypeInfo, 1, softStringTypeInfo, QORE_PARAM_NO_ARG, "key");

    // bool PseudoNothing::hasKeyValue(softstring key){}
    QC_PSEUDONOTHING->addMethod("hasKeyValue", (q_method_n_t)PseudoNothing_hasKeyValue_vs, Public, QCF_CONSTANT, QDOM_DEFAULT, boolTypeInfo, 1, softStringTypeInfo, QORE_PARAM_NO_ARG, "key");

    // SingleValueIterator PseudoNothing::keyIterator(){}
    QC_PSEUDONOTHING->addMethod("keyIterator", (q_method_n_t)PseudoNothing_keyIterator, Public, QCF_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

    // list<string> PseudoNothing::keys(){}
    QC_PSEUDONOTHING->addMethod("keys", (q_method_n_t)PseudoNothing_keys, Public, QCF_CONSTANT, QDOM_DEFAULT, qore_get_complex_list_type(stringTypeInfo));

    // nothing PseudoNothing::lastKey(){}
    QC_PSEUDONOTHING->addMethod("lastKey", (q_method_n_t)PseudoNothing_lastKey, Public, QCF_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

    // nothing PseudoNothing::lastValue(){}
    QC_PSEUDONOTHING->addMethod("lastValue", (q_method_n_t)PseudoNothing_lastValue, Public, QCF_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

    // int PseudoNothing::lsize(){}
    QC_PSEUDONOTHING->addMethod("lsize", (q_method_n_t)PseudoNothing_lsize, Public, QCF_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

    // SingleValueIterator PseudoNothing::pairIterator(){}
    QC_PSEUDONOTHING->addMethod("pairIterator", (q_method_n_t)PseudoNothing_pairIterator, Public, QCF_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

    // SingleValueIterator PseudoNothing::rangeIterator(){}
    QC_PSEUDONOTHING->addMethod("rangeIterator", (q_method_n_t)PseudoNothing_rangeIterator, Public, QCF_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

    // int PseudoNothing::typeCode(){}
    QC_PSEUDONOTHING->addMethod("typeCode", (q_method_n_t)PseudoNothing_typeCode, Public, QCF_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

    // list<auto> PseudoNothing::values(){}
    QC_PSEUDONOTHING->addMethod("values", (q_method_n_t)PseudoNothing_values, Public, QCF_CONSTANT, QDOM_DEFAULT, autoListTypeInfo);

    return QC_PSEUDONOTHING;
}
