/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_AbstractIterator.qpp AbstractIterator class (interface) definition */
/*
  Qore Programming Language

  Copyright (C) 2003 - 2024 Qore Technologies, s.r.o.

  Permission is hereby granted, free of charge, to any person obtaining a
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation
  the rights to use, copy, modify, merge, publish, distribute, sublicense,
  and/or sell copies of the Software, and to permit persons to whom the
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
  DEALINGS IN THE SOFTWARE.

  Note that the Qore library is released under a choice of three open-source
  licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
  information.
*/

#include <qore/Qore.h>
/* Qore class Qore::AbstractIterator */

qore_classid_t CID_ABSTRACTITERATOR;
QoreClass* QC_ABSTRACTITERATOR;

DLLLOCAL void preinitAbstractIteratorClass() {
    QC_ABSTRACTITERATOR = new QoreBuiltinClass("AbstractIterator", "::Qore::AbstractIterator", QDOM_DEFAULT);
    CID_ABSTRACTITERATOR = QC_ABSTRACTITERATOR->getID();
    QC_ABSTRACTITERATOR->setSystem();
}

DLLLOCAL QoreClass* initAbstractIteratorClass(QoreNamespace& ns) {
    if (!QC_ABSTRACTITERATOR)
        preinitAbstractIteratorClass();

    // auto AbstractIterator::getValue();
    QC_ABSTRACTITERATOR->addAbstractMethod("getValue", Public, QCF_NO_FLAGS, autoTypeInfo);

    // bool AbstractIterator::next();
    QC_ABSTRACTITERATOR->addAbstractMethod("next", Public, QCF_NO_FLAGS, boolTypeInfo);

    // bool AbstractIterator::valid();
    QC_ABSTRACTITERATOR->addAbstractMethod("valid", Public, QCF_NO_FLAGS, boolTypeInfo);

    return QC_ABSTRACTITERATOR;
}
