/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_LoggerLayout.cpp LoggerLayout class definition */
/*
    Qore Programming Language

    Copyright (C) 2003 - 2024 Qore Technologies, s.r.o.

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

    Note that the Qore library is released under a choice of three open-source
    licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
    information.
*/

#include "qore_logger.h"

#include "QC_LoggerLayout.h"
/* Qore class Qore::Logger::LoggerLayout */

qore_classid_t CID_LOGGERLAYOUT;
QoreClass* QC_LOGGERLAYOUT;

DLLLOCAL void preinitLoggerLayoutClass() {
    QC_LOGGERLAYOUT = new QoreBuiltinClass("LoggerLayout", "::Qore::Logger::LoggerLayout", QDOM_DEFAULT);
    CID_LOGGERLAYOUT = QC_LOGGERLAYOUT->getID();
    QC_LOGGERLAYOUT->setSystem();
}

DLLLOCAL QoreClass* initLoggerLayoutClass(QoreNamespace& ns) {
    if (!QC_LOGGERLAYOUT)
        preinitLoggerLayoutClass();

    // string LoggerLayout::format(LoggerEvent event);
    QC_LOGGERLAYOUT->addAbstractMethod("format", Public, QCF_NO_FLAGS, stringTypeInfo, 1, QC_LOGGEREVENT->getTypeInfo(), QORE_PARAM_NO_ARG, "event");

    return QC_LOGGERLAYOUT;
}
